if not v then v = {} end

dofile("scripts/inc_flags.lua")

v.node = 0
v.save = false
v.on = false

local function doActivate(me)
    
    if not v.on then
        debugLog("Turn on node: " .. node_getName(v.node))
        node_setActive(v.node, true)
        if me == getNodeToActivate() then
            debugLog("... debug only")
        else
            node_setFlag(me, 1)
        end
        v.on = true
       
    -- allow turning on/off manually for debugging
    elseif v.isDebug() and me == getNodeToActivate() then
        debugLog("Turn off node: " .. node_getName(v.node))
        node_setActive(v.node, false)
        v.on = false
    end
    
    v.nodeDebugVis(me, v.on)
end

function init(me)
    v.node = node_getNearestNode(me, node_getContent(me))
    v.save = node_getAmount(me) ~= 0
    
    if v.isDebug() then
        node_setCursorActivation(me, true)
    end
    local on = node_getFlag(me) ~= 0
    v.nodeDebugVis(me, on)
    if on then
        doActivate(me)
    end
end

function update(me, dt)
end

function activate(me, e)
    doActivate(me)
end

function songNote(me, note)
end

function songNoteDone(me, note, done)
end
